<?php
// unlimit time
@set_time_limit(0);

function CheckAbilityOfInstallation() {
  global $db;
  global $MODULE_FOLDER, $TMP_FOLDER, $HTTP_ROOT_PATH, $SUB_FOLDER, $DOCUMENT_ROOT;
  
	$result['Success'] = 1;
	$result['ErrorMessage'] = TOOLS_PATCH_ERROR;
  
  if ( !nc_installer_check_php_version() ) {
    $result['Success'] = 0;
    // error text
    $result['ErrorMessage'] = str_replace("%CURRENT", phpversion(), str_replace("%NEED", "5.1", TOOLS_PATCH_ERROR_UNCORRECT_PHP_VERSION) );
    // return error
    return $result;
  }

	// check if all files are writeable
	$files = file($TMP_FOLDER."files.txt");

	// add check for module files
	$installed_modules = $db->get_results("SELECT `Keyword` FROM `Module`", ARRAY_A);
	if( !empty($installed_modules) ) {
		foreach ($installed_modules as $module) {
			if (file_exists($MODULE_FOLDER.$module['Keyword'])) {
				$module_files = nc_installer_filelist($TMP_FOLDER."modules/".$module['Keyword']);
				foreach ((array)$module_files AS $module_file) {
					$files[] = $SUB_FOLDER.$HTTP_ROOT_PATH."modules/".$module['Keyword']."/".$module_file;
				}
			}
		}
	}

	foreach ($files AS $file) {
		$file = $DOCUMENT_ROOT.rtrim($file);
		if (file_exists($file)) {
      // file is not writable
			if ( !is_writable($file) && !@chmod($file, 0777) ) {
				$result['ErrorMessage'] = str_replace("%FILE", $file, TOOLS_PATCH_ERROR_SET_FILEPERM_IN_HTTP_ROOT_PATH);
				$result['Success'] = 0;
			}
		}
		else {
		// check dir
			###if(!$dirname) continue;
			$dirname = dirname($file);
			// find the nearest existing parent directory
			while ( !file_exists($dirname) ) {
				$dirname = preg_replace("!/[^/]+$!", "", $dirname);
				if ( $dirname==$DOCUMENT_ROOT.rtrim($HTTP_ROOT_PATH, "/") ) break;
			}
			// directory is not writable
			if ( !is_writable($dirname) && !@chmod($dirname, 0777) ) {
				$result['ErrorMessage'] = str_replace("%DIR", $dirname, TOOLS_PATCH_ERROR_SET_DIRPERM_IN_HTTP_ROOT_PATH);
				$result['Success'] = 0;
			}
		}
	}

  return $result;
}


/**
 * эта функция выполняется самой первой, но после всех проверок и CheckAbilityOfInstallation()
 *
 * @return array result data
 */
function InstallPatch() {
  global $ADMIN_FOLDER,$TMP_FOLDER, $MODULE_FOLDER, $ROOT_FOLDER, $db, $nc_core;
  require_once $ADMIN_FOLDER."class/import.inc.php";
	
	$TMP_FOLDER = str_replace("#", "/", $TMP_FOLDER);

	$result['Success'] = 1;
	$result['ErrorMessage'] = TOOLS_PATCH_ERROR;

	// SystemID
  $settings = $db->get_row("SELECT * FROM Settings", ARRAY_A);
  $SystemID = $settings['SystemID'];
  
  /* Конвертация таблицы Settings */
  //удаляем старую таблицу
  $db->query("DROP TABLE IF EXISTS `Settings`");

  //создаем таблицу с другой структурой
  $db->query("CREATE TABLE IF NOT EXISTS `Settings` (`Settings_ID` int(11) NOT NULL AUTO_INCREMENT, `Key` varchar(255) NOT NULL, `Value` text NOT NULL, `Module` varchar(255) NOT NULL DEFAULT 'system', `Catalogue_ID` int(11) NOT NULL DEFAULT '0', PRIMARY KEY (`Settings_ID`), KEY `Catalogue_ID` (`Catalogue_ID`) ) ENGINE=MyISAM DEFAULT CHARSET=".$nc_core->MYSQL_CHARSET." ");
  if ( $db->is_error ) echo "<br/>".$db->last_error."<br/>";
  
  //собираем все старые значения, кроме EditorStyles
  foreach ($settings as $k=>$v) {
    if ($k != 'EditorStyles') {
      $settings_arr[] = "('$k', '".$db->escape($v)."')";
    }
  }
  $settings_arr[] = "('AdminNoticeResponse','')";
  $settings_arr[] = "('TrashUse','0')";
  $settings_arr[] = "('TrashLimit','20')";
  $settings_arr[] = "('CKEditorSkin','office2003')";
  
  //заносим в новую таблицу старые значения
  $db->query("INSERT INTO `Settings` (`Key`, `Value`) VALUES ".join(', ', $settings_arr).";");

  //делаем апдейт значений, которые немного изменились
  $email_field = $db->get_var("SELECT `Field_Name` FROM `Field` WHERE `Field_ID` = '".$settings['UserEmailField']."'");
  $db->query("UPDATE `Settings` SET `Value` = '".$email_field."' WHERE `Key` = 'UserEmailField';");
  $db->query("UPDATE `Settings` SET `Value` = '".time()."' WHERE `Key` = 'PatchCheck';");
  
  /* Добавление сео-полей к Message */
  $m_tables = $db->get_col("SHOW TABLES LIKE 'Message%'");
  if ( $m_tables ) foreach ( $m_tables as $v ) {
    $db->query("ALTER TABLE `".$v."` ADD `ncTitle` VARCHAR(255) DEFAULT NULL, ADD `ncKeywords` VARCHAR(255) DEFAULT NULL, ADD `ncDescription` TEXT DEFAULT NULL");
    if ( $db->is_error ) echo "Table ".$v.":<br/>".$db->last_error."<br/>";
  }
  
  /* установка виджетов */
  $db->query("ALTER TABLE `Field` ADD `Widget_Class_ID` int(11) NOT NULL default '0', ADD `Checked` TINYINT(1) NOT NULL DEFAULT 1;");
  nc_widget_patch_sql();

  if (extension_loaded('SimpleXML')) {
    nc_widget_patch_import();
  }
  else {
    nc_print_status( to_uni("На вашем сервере отстутсвует расширение PHP SimpleXML. Из-за этого импорт предустановленных виджетов невозможен. После установки данного расширения вы можете скачать предустановленные виджеты с <a href='http://netcat.ru/products/widgets/' target='_blank'>сайта NetCat</a> и импортировать их вручную."), 'info');
  }
  
  /* создание шаблонов компонента для корзины удаленных объектов */
  $db->query("ALTER TABLE `Class` ADD `TitleList` VARCHAR(255) DEFAULT NULL, ADD `UseAltTitle` TINYINT DEFAULT 0, MODIFY `Type` enum('rss','useful','admin_mode','inside_admin','xml','trash','title');");
  nc_patch_make_trash ();
	
	// список установленных модулей  
  $installed_modules = $db->get_col("SELECT `Keyword` FROM `Module`");
  
  // новые поля в Subdivision и Catalogue
  $f_u = nc_patch_seo ( in_array('search', $installed_modules) );
  $db->query("INSERT INTO `Settings` (`Key`, `Value`) VALUES ('FieldUsage','". serialize($f_u)."')");
  
  // переименование старого модуля поиска в searchold
  if ( in_array('search', $installed_modules ) ) {
    rename($MODULE_FOLDER.'search', $MODULE_FOLDER.'searchold');
    $c = file_get_contents($MODULE_FOLDER.'searchold/cron.php');
    $c = str_replace("MODULE_VARS['search']", "MODULE_VARS['searchold']", $c);
    file_put_contents($MODULE_FOLDER.'searchold/cron.php', $c);
    $c = file_get_contents($MODULE_FOLDER.'searchold/crontab.php');
    $c = str_replace("MODULE_VARS[search]", "MODULE_VARS[searchold]", $c);
    file_put_contents($MODULE_FOLDER.'searchold/crontab.php', $c);
    
    $installed_modules[] = "searchold";
  }
	
	// модуль МИНИШОП
	switch ($SystemID) { 
		case 3: // Extra
    case 6: // E-Commerce
		case 8: // Corporate
			$installed_modules[] = "minishop";
		break;
	}

  
	foreach ($installed_modules AS $keyword) {
		// Execute SQL, if any
		if ( file_exists($TMP_FOLDER."modules/".$keyword.".sql") ) {
			ExecSQL($TMP_FOLDER."modules/".$keyword.".sql");
		}

		// Create DIR if not exist
		if ( !file_exists($MODULE_FOLDER.$keyword) ) {
			@mkdir($MODULE_FOLDER.$keyword, 0755);
		}

		// Copy all files to modules folder
		nc_installer_copy_all($TMP_FOLDER."modules/".$keyword, $MODULE_FOLDER.$keyword);

		// include script if necessary
		if ( file_exists($TMP_FOLDER."modules/".$keyword.".inc.php") ) {
			include ($TMP_FOLDER."modules/".$keyword.".inc.php");
		}

		// Remove old files
		if( file_exists($TMP_FOLDER."modules/".$keyword.".remove") ) {
			$files_to_remove = file($TMP_FOLDER."modules/".$keyword.".remove");
			foreach ($files_to_remove AS $file) {
				$file = trim($file, "\r\n/");
				if( @is_dir($ROOT_FOLDER.$file) ) {
					@rmdir($ROOT_FOLDER.$file);
				}
				else {
					@unlink($ROOT_FOLDER.$file);
				}
			}
		}
	}

  $db->query("UPDATE `Module` SET `Inside_Admin` = 1 WHERE `Keyword` IN ('calendar','cache','auth','forum2','logging','search','subscriber','tagscloud','minishop' )" );
  $db->query("UPDATE `Settings` SET `Value` = '4.5' WHERE `Key` = 'VersionNumber'");
  return $result;
}


function InstallPatchAfterAction() {
  global $Description, $db, $PatchResult, $PatchResultText;
  global $ADMIN_FOLDER, $SUB_FOLDER, $ADMIN_PATH;

	$changelog = nc_patch_changelog();
	if($changelog) {
		if ( !function_exists("AddSystemMessage") ) {
			include ($ADMIN_FOLDER."report/system.inc.php");
		}
		
		// AddSystemMessage(message, title), их бы местами поменять *(O_o)*
		###  ($PatchResultText ? $PatchResultText."\r\n" : "") - сколько файлов скопировано и запросов выполнено, без учёта модулей
		$sysmess = AddSystemMessage($changelog, $Description ? $Description : TOOLS_PATCH_INSTALLED);

		// инфоблок о новом системном сообщении
		if($sysmess) {
			nc_print_status( str_replace("%LINK", ($ADMIN_PATH ? $SUB_FOLDER.$ADMIN_PATH : "/netcat/admin/")."report/system.php?SystemMessageID=".$sysmess, TOOLS_PATCH_INFO_SYSTEM_MESSAGE), "info" );
		}
	}
  
  nc_print_status( to_uni("Обязательно очистите кэш браузера!"), 'info');
  nc_print_status( to_uni("Посмотреть примечание можно на сайте <a href='http://netcat.ru/adminhelp/patch453'>netcat.ru</a>"), 'info');


  return true;
}

function nc_installer_check_php_version () {
  // version must be >= 5.1
  if ( preg_match("/^(\d)\.(\d)/is", phpversion(), $matches) ) {
    if ( intval($matches[1].$matches[2]) >= 51 ) return true;
  }
  // version oldest
  return false;
}

function nc_installer_copy_all($from, $to) {

	$from = str_replace("#", "/", $from);
	$to = str_replace("#", "/", $to);

	$dh = @opendir($from);
	if(!$dh) return false;

	while( ( $file = readdir($dh) )!==false ) {
		if($file=="." || $file=="..") continue;
		if( @is_dir($from."/".$file) ) {
			@mkdir($to."/".$file, 0755);
			nc_installer_copy_all($from."/".$file, $to."/".$file);
		}
		else {
			copy($from."/".$file, $to."/".$file);
		}
	}

	closedir($dh);

  return true;
}


function nc_installer_filelist($dir) {

	$dir = str_replace("#", "/", $dir);
	if (!$level) $start_dir = $dir;

	$ret = array();
	// non-existent dir may be passed
	$dh = @opendir($dir); 

	if (!$dh) return false;

	while ( ($file = readdir($dh))!==false ) {
		if ($file=="." || $file=="..") continue;
		if ( is_dir($dir."/".$file) ) {
			$ret = array_merge( $ret, nc_installer_filelist($dir."/".$file) );
		}
		else {
			$ret[] = preg_replace("!^$start_dir/!", "", $dir."/".$file);
		}
	}

	closedir($dh);
	
  return $ret;
}

function nc_widget_patch_sql () {
  global $nc_core, $db;
  $db->query("
  CREATE TABLE `Widget_Class` (
  `Widget_Class_ID` int(11) NOT NULL auto_increment,
  `Name` varchar(255) NOT NULL,
  `Keyword` varchar(255) NOT NULL,
  `Description` text default NULL,
  `Category` text default NULL,
  `InDevelop` tinyint(4) NOT NULL default '0',
  `Template` text NOT NULL default '',
  `Settings` text NOT NULL default '',
  `AddForm` text NOT NULL default '',
  `EditForm` text NOT NULL default '',
  `User_ID` int(11) NOT NULL default '0',
  `LastUser_ID` int(11) NOT NULL default '0',
  `Created` datetime NOT NULL default '0000-00-00 00:00:00',
  `LastUpdated` timestamp NOT NULL on update CURRENT_TIMESTAMP,
  `WidgetDisallow` tinyint(4) NOT NULL default '0',
  `Update` int(11) NOT NULL default '0',
  PRIMARY KEY  (`Widget_Class_ID`),
  KEY `User_ID` (`User_ID`),
  KEY `LastUser_ID` (`LastUser_ID`)
  ) ENGINE=MyISAM DEFAULT CHARSET=".$nc_core->MYSQL_CHARSET."; ");
  
  $db->query("
    CREATE TABLE `Widget` (
    `Widget_ID` int(11) NOT NULL auto_increment,
    `Widget_Class_ID` int(11) NOT NULL default '0',
    `Name` varchar(255) NOT NULL,
    `Keyword` varchar(255) NOT NULL,
    `Result` text NOT NULL default '',
    `User_ID` int(11) NOT NULL default '0',
    `LastUser_ID` int(11) NOT NULL default '0',
    `Created` datetime NOT NULL default '0000-00-00 00:00:00',
    `LastUpdated` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
    PRIMARY KEY  (`Widget_ID`),
    KEY `Widget_Class_ID` (`Widget_Class_ID`),
    KEY `User_ID` (`User_ID`)
    ) ENGINE=MyISAM DEFAULT CHARSET=".$nc_core->MYSQL_CHARSET."; ");
    
  $db->query("
    CREATE TABLE `Widget_Field` (
      `ID` int(11) NOT NULL auto_increment,
      `Widget_ID` int(11) NOT NULL default '0',
      `Field_ID` int(11) NOT NULL default '0',
      `Value` text default NULL,
      PRIMARY KEY  (`ID`),
      KEY `Widget_ID` (`Widget_ID`),
      KEY `Field_ID` (`Field_ID`)
    ) ENGINE=MyISAM DEFAULT CHARSET=".$nc_core->MYSQL_CHARSET."; ");
}

function nc_widget_patch_import() {
  global $TMP_FOLDER;
  $a = array( 'netcat_facebook_activity_feed_widgetclass.wct','netcat_facebook_like_widgetclass.wct','netcat_google_youtube_widgetclass.wct','netcat_rss_widgetclass.wct',
  'netcat_twitter_follow_widgetclass.wct','netcat_twitter_profile_widgetclass.wct','netcat_twitter_search_widgetclass.wct',
  'netcat_twitter_tweetbutton_widgetclass.wct','netcat_video_56_com_widgetclass.wct','netcat_video_bigmir_net_widgetclass.wct',
  'netcat_video_online_ua_widgetclass.wct','netcat_video_rutube_ru_widgetclass.wct','netcat_video_smotri_com_widgetclass.wct',
  'netcat_video_veoh_com_widgetclass.wct','netcat_video_vimeo_com_widgetclass.wct','netcat_video_yandex_ru_widgetclass.wct',
  'netcat_vkontakte_comment_widgetclass.wct','netcat_vkontakte_link_widgetclass.wct','netcat_whoyougle_adres_widgetclass.wct',
  'netcat_whoyougle_konverter_valut_widgetclass.wct','netcat_whoyougle_kurs_valut_widgetclass.wct','netcat_whoyougle_nds_widgetclass.wct',
  'netcat_whoyougle_oo_widgetclass.wct','netcat_whoyougle_stavki_widgetclass.wct','netcat_whoyougle_znaete_widgetclass.wct',
  'netcat_yandex_dai_rub_widgetclass.wct','netcat_yandexmaps_widgetclass.wct','netcat_yandex_novosti_widgetclass.wct',
  'netcat_yandex_podelitsa_widgetclass.wct','netcat_yandex_pogoda_widgetclass.wct','netcat_yandex_probki_widgetclass.wct');
  foreach ( $a as $v ) {
    nc_widgetclass_import( array('tmp_name' => $TMP_FOLDER."widgets/".$v) );
  }

 
}


function nc_widgetclass_import($import) {
  global $db, $nc_core;

  $file = file_get_contents($import['tmp_name']);
  $xml = new SimpleXmlElement($file, LIBXML_NOCDATA);
  $widgetclass = array();
  $widgetclass['Name'] = (string) $xml->widgetclasses->widgetclass->Name;
  $widgetclass['Keyword'] = (string) $xml->widgetclasses->widgetclass->Keyword;
  $widgetclass['Description'] = (string) $xml->widgetclasses->widgetclass->Description;
  $widgetclass['Category'] = (string) $xml->widgetclasses->widgetclass->Category;
  $widgetclass['InDevelop'] = (string) $xml->widgetclasses->widgetclass->InDevelop;
  $widgetclass['Template'] = (string) $xml->widgetclasses->widgetclass->Template;
  $widgetclass['Settings'] = (string) $xml->widgetclasses->widgetclass->Settings;
  $widgetclass['AddForm'] = (string) $xml->widgetclasses->widgetclass->AddForm;
  $widgetclass['EditForm'] = (string) $xml->widgetclasses->widgetclass->EditForm;
  $widgetclass['WidgetDisallow'] = (string) $xml->widgetclasses->widgetclass->WidgetDisallow;
  $widgetclass['Update'] = (string) $xml->widgetclasses->widgetclass->Update;

  $id = nc_widget_add_widgetclass($widgetclass, 1);

  $query = "INSERT INTO `Field` (`Field_Name`, `Description`, `Format`, `NotNull`, `Priority`, `DoSearch`, `DefaultState`, `Inheritance`, `Widget_Class_ID`, `TypeOfEdit_ID`, `TypeOfData_ID`) VALUES ";
  foreach ($xml->fields->field as $field) {
    $query_arr[] = "('".(string) $field->Field_Name."', '".(string) $field->Description."', '".(string) $field->Format."', ".(string) $field->NotNull.", ".(string) $field->Priority.", ".(string) $field->DoSearch.", '".(string) $field->DefaultState."', ".(string) $field->Inheritance.", ".$id.", ".(string) $field->TypeOfEdit_ID.", ".(string) $field->attributes()->type_of_data_id.")";  
  }
  $query .= implode(',',  $query_arr);
  $db->query($query);
  return $id;

}
function to_uni($string) {
  global $nc_core;
  return ($nc_core->NC_UNICODE ? $string : $nc_core->utf8->utf2win($string));
}

function to_u($string) {
  return to_uni($string);
}

function nc_widget_add_widgetclass ( $params ) {
  global $AUTH_USER_ID, $db;
  foreach ($params as $p => $value) {
    $query_key[] = "`".$p."`";
    $query_key_assist[] = $p;
    $query_par[] = "'".$db->escape(addslashes($params[$p]))."'";
    $query_par_assist[] = $db->escape(addslashes($params[$p]));
  }
    
  $query = "INSERT INTO `Widget_Class` (".implode(',', $query_key).",`User_ID`,`LastUser_ID`,`Created`,`LastUpdated`) VALUES (".implode(',', $query_par).",'".$AUTH_USER_ID."','".$AUTH_USER_ID."','".date('Y-m-d H:i:s')."','".date('Y-m-d H:i:s')."')";

  $db->query(to_uni($query));
  return $db->insert_id;
}

function nc_patch_make_trash () {
  global $db;
  // узнаем используемые компоненты
  $classes = $db->get_col("SELECT DISTINCT c.`Class_ID` FROM `Class` as c, `Sub_Class` as `sc` WHERE  sc.`Class_ID` = c.`Class_ID` AND c.`System_Table_ID` = 0");
  if ( !$classes ) return false;
  
  // выбираем все поля
  $fields = $db->get_results("SELECT `Field_Name`, `TypeOfData_ID`, `Class_ID` FROM `Field` WHERE `TypeOfData_ID` IN ( 1,3) AND `Class_ID` IN (".join(',', $classes).") ", ARRAY_A);
  foreach ( $fields as $v ) {
    $fields_string[$v['Class_ID']][]  = $v['Field_Name'];
  }
  
  // определение полей, которые будут использоваться в шаблоне
  foreach ( $classes as $class_id ) {
    $title = '';
    if ( !empty($fields_string[$class_id]) ) foreach ( $fields_string[$class_id] as $v ) {
      if ( nc_preg_match('/(titl|caption|name|subject)/i', $v) ) {
        $title = 'f_'.$v;
        break;
      }
    }
    if ( !$title &&  !empty($fields_string[$class_id]) ) foreach ( $fields_string[$class_id] as $v ) {
      if ( nc_preg_match('/(text|content)/i', $v) ) {
        $title = 'f_'.$v;
        break;
      }
    }
    
    if ( !$title ) $title = 'f_RowID';
    $record = '$f_AdminButtons $'.$title."<br /><br />\r\n";
    
    $values[] = "('".$class_id."', 'trash', '".SECTION_INDEX_DEV_CLASS_TEMPLATES."', '".$db->escape($record)."', '".to_uni('Для корзины удаленных объектов')."') ";
  }
  
  $db->query("INSERT INTO `Class` ( `ClassTemplate`, `Type`, `Class_Group`, `RecordTemplate`, `Class_Name`) VALUES ".join(',',$values)."" ); 
}


function nc_patch_seo ( $m_search ) {
  global $db;
  $array_to_add = Array( 
    'last_modified' => 'LastModified',
    'last_modified_type' => 'LastModifiedType',
    'title' => 'Title',
    'sitemap_include' => 'IncludeInSitemap',
    'sitemap_changefreq' => 'SitemapChangefreq',
    'sitemap_priority' => 'SitemapPriority'
  );

  $res = array();
  $array_result = array();
  $field_sub = array();
  $field_cat = array();

  $cols1 = $db->get_results("SHOW COLUMNS FROM `Subdivision`",ARRAY_A);
  $cols2 = $db->get_results("SHOW COLUMNS FROM `Catalogue`",  ARRAY_A);

  foreach($cols1 as $v){
    $field_sub[] = $v["Field"];
    if( in_array($v["Field"],$array_to_add) ){
      $res[] = $v["Field"];
    }
  }
  foreach($cols2 as $v){
    $field_cat[] = $v["Field"];
    if( in_array($v["Field"],$array_to_add) ){
      $res[] = $v["Field"];
    }
  }
  $res = array_unique($res);

  // LastModified
  if( in_array('LastModified', $res) ){
    $array_to_add['last_modified'] = 'ncLastModified';
  }
  $db->query("ALTER TABLE `Subdivision` ADD `".$array_to_add['last_modified']."` datetime default NULL");
  $db->query("ALTER TABLE `Catalogue` ADD `".$array_to_add['last_modified']."` datetime default NULL");
  
  // LastModifiedType
  if( in_array('LastModifiedType', $res) ){
    $array_to_add['last_modified_type'] = 'ncLastModifiedType';
  }
  $db->query("ALTER TABLE `Subdivision` ADD `".$array_to_add['last_modified_type']."` int(11) default '0'");
  $db->query("ALTER TABLE `Catalogue` ADD `".$array_to_add['last_modified_type']."` int(11) default '1'");
  
  // Title
  //if( in_array('Title', $res) ){
  $array_to_add['title'] = 'ncTitle';
  //}
  $db->query("ALTER TABLE `Subdivision` ADD `".$array_to_add['title']."` varchar(255) default NULL");
  
  if ( !in_array('Language', $field_sub) ) {
    $db->query("ALTER TABLE `Subdivision` ADD `Language` VARCHAR( 255 )  default NULL");
  }
  if ( !in_array('Keywords', $field_sub) ) {
    $db->query("ALTER TABLE `Subdivision` ADD `Keywords` TEXT");
  }
  if ( !in_array('Description', $field_sub) ) {
    $db->query("ALTER TABLE `Subdivision` ADD `Description` TEXT");
  }
  if ( !in_array('Keywords', $field_cat) ) {
    $db->query("ALTER TABLE `Catalogue` ADD `Keywords` TEXT");
  }
  if ( !in_array('Description', $field_cat) ) {
    $db->query("ALTER TABLE `Catalogue` ADD `Description` TEXT");
  }
  
  $db->query("DELETE FROM `Field` WHERE `Field_Name` IN ('Keywords', 'Description') AND `System_Table_ID` IN (1,2)");
    
  if ( $m_search ) {
    // IncludeInSitemap
    if( in_array('IncludeInSitemap', $res) ){
      $array_to_add['sitemap_include'] = 'nc_IncludeInSitemap';
    }
    $db->query("ALTER TABLE `Subdivision` ADD `".$array_to_add['sitemap_include']."` int(11) default '-1'");
    $db->query("ALTER TABLE `Catalogue` ADD `".$array_to_add['sitemap_include']."` int(11) default '1'");
    // SitemapChangefreq
    if( in_array('SitemapChangefreq', $res) ){
      $array_to_add['sitemap_changefreq'] = 'nc_SitemapChangefreq';
    }
    $db->query("ALTER TABLE `Subdivision` ADD `".$array_to_add['sitemap_changefreq']."` enum('always','hourly','daily','weekly','monthly','yearly','never') default 'daily'");
    $db->query("ALTER TABLE `Catalogue` ADD `".$array_to_add['sitemap_changefreq']."` enum('always','hourly','daily','weekly','monthly','yearly','never') default 'daily'");
    // IncludeInSitemap
    if( in_array('SitemapPriority', $res) ){
      $array_to_add['sitemap_priority'] = 'nc_SitemapPriority';
    }
    $db->query("ALTER TABLE `Subdivision` ADD `".$array_to_add['sitemap_priority']."` float default NULL");
    $db->query("ALTER TABLE `Catalogue` ADD `".$array_to_add['sitemap_priority']."` float default '0.5'");
  }
  
  $array_to_add['keywords'] = 'Keywords';
  $array_to_add['description'] = 'Description';
  $array_to_add['language'] = 'Language';


  return $array_to_add;

}

?>
