<?php

/* $Id: normalize.php 4693 2011-05-14 22:57:30Z denis $ */

/**
 * Нормализация строки: замена сущностей html на соответствующие символы,
 * приведение к UTF NFC
 */
class nc_search_language_filter_normalize extends nc_search_language_filter {

  static protected function decode_entity($entity) {
    $convmap = array(0x0, 0x10000, 0, 0xfffff);
    return mb_decode_numericentity($entity, $convmap, 'UTF-8');
  }

  public function filter(array $terms) {
    $fn = get_class($this) . "::decode_entity";
    $has_normalizer = class_exists("Normalizer", false);
    
    for ($i=0, $max = sizeof($terms); $i < $max; $i++) {
      // убрать HTML Entities
      $terms[$i] = html_entity_decode($terms[$i], ENT_QUOTES, MAIN_ENCODING);
      
      // Приведение к нормальной C-форме UTF
      if ($has_normalizer) { // расширение intl (PHP 5.2+)
        $terms[$i] = Normalizer::normalize($terms[$i], Normalizer::FORM_C);
      }
    }
    return $terms;
  }

}