<?php

/* $Id: synonyms.php 4693 2011-05-14 22:57:30Z denis $ */

/**
 * Добавление синонимов
 */
class nc_search_language_filter_synonyms extends nc_search_language_filter {

  static protected $lists = array();

  public function filter(array $terms) {
    $language = $this->context->get('language');

    if (!isset(self::$lists[$language])) {
      $query = "SELECT * FROM `%t%` WHERE `Language`='" . nc_search_util::db_escape($language) . "'";
      self::$lists[$language] = nc_search::load('nc_search_language_synonyms', $query);
    }

    if (!sizeof(self::$lists[$language])) { return $terms; } // nothing to do

    $result = $terms;
    // this might be quite slow on a big synonym dictionary... place for further optimization
    foreach ($terms as $term) {
      foreach (self::$lists[$language] as $entry) {
        $synonyms = $entry->get('words'); // array
        foreach ( $synonyms as $k => $v ) {
          $synonyms[$k] = nc_search_util::convert($v, 1);
        }
        if (in_array($term, $synonyms)) {
          $result = array_merge($result, $synonyms);
          $result = array_unique($result);
          sort($result, SORT_STRING); // не обязательно в соответствии с локалью
          break; // use the first match only
        }
      }
    }
    return array_unique($result);
  }



}
