<?php

if (!class_exists("nc_system")) { die; }
$ui = $this->get_ui();
$ui->add_settings_toolbar();
$ui->add_submit_button(NETCAT_MODULE_SEARCH_ADMIN_SETTINGS_SAVE);

// СОХРАНИТЬ НАСТРОЙКИ
$new_settings = $this->get_input('s', array());
if ($new_settings) {
  $new_settings["EnableQuerySuggest"] = (strlen($new_settings["SuggestMode"]) > 0);
  foreach ($new_settings as $k => $v) { 
    nc_search::save_setting($k, $v); 
  }
  nc_print_status(NETCAT_MODULE_SEARCH_ADMIN_SETTINGS_SAVED, 'ok');
}

// ПОКАЗАТЬ ФОРМУ
$suggest_mode = nc_search::get_setting('SuggestMode');
$suggest_enabled = nc_search::should('EnableQuerySuggest');

?>
<form method="POST" class="settings">
  <input type="hidden" name="view" value="templates" />
  
  <fieldset>
    <legend><?=NETCAT_MODULE_SEARCH_ADMIN_INTERFACE_RESULTS ?></legend>
    <?=$this->setting_cb('ShowMatchedFragment', NETCAT_MODULE_SEARCH_ADMIN_INTERFACE_SHOW_MATCHED_FRAGMENT) ?>
    <?=$this->setting_cb('HighlightMatchedWords', NETCAT_MODULE_SEARCH_ADMIN_INTERFACE_HIGHLIGHT_MATCHED) ?>
    <?=$this->setting_cb('AllowFieldSort', NETCAT_MODULE_SEARCH_ADMIN_INTERFACE_ALLOW_FIELD_SORT) ?>
    <?=$this->setting_cb('OpenLinksInNewWindow', NETCAT_MODULE_SEARCH_ADMIN_INTERFACE_OPEN_LINKS_IN_NEW_WINDOW) ?>

    <div class="setting">
        <?=NETCAT_MODULE_SEARCH_ADMIN_INTERFACE_RESULTS_TITLE_WORD_COUNT ?>:
        <input type='text' name='s[ResultTitleMaxNumberOfWords]' class='i3' 
               value='<?=htmlspecialchars(nc_search::get_setting('ResultTitleMaxNumberOfWords')) ?>' />
    </div>
    <div class="setting">
        <?=NETCAT_MODULE_SEARCH_ADMIN_INTERFACE_RESULTS_FRAGMENT_WORD_COUNT ?>:
        <input type='text' name='s[ResultContextMaxNumberOfWords]' class='i3' 
               value='<?=htmlspecialchars(nc_search::get_setting('ResultContextMaxNumberOfWords')) ?>' />
    </div>
  </fieldset>
    
  <fieldset>
    <legend><?=NETCAT_MODULE_SEARCH_ADMIN_INTERFACE_ADVANCED_SEARCH ?></legend>
    <?=$this->setting_cb('EnableAdvancedSearchForm', NETCAT_MODULE_SEARCH_ADMIN_INTERFACE_ENABLE_ADVANCED_SEARCH_FORM) ?>
    <div class="setting">
      <div class="caption"><?=NETCAT_MODULE_SEARCH_ADMIN_INTERFACE_ADVANCED_SEARCH_FORM_OPTIONS ?>:</div>
      <blockquote>
        <?=$this->setting_cb('ShowAdvancedFormExcludeField', NETCAT_MODULE_SEARCH_ADMIN_INTERFACE_ADVANCED_SEARCH_EXCLUDE) ?>
        <?=$this->setting_cb('ShowAdvancedFormFieldSearch', NETCAT_MODULE_SEARCH_ADMIN_INTERFACE_ADVANCED_SEARCH_FIELD) ?>
        <?=$this->setting_cb('ShowAdvancedFormTimeIntervals', NETCAT_MODULE_SEARCH_ADMIN_INTERFACE_ADVANCED_SEARCH_DATETIME) ?>
      </blockquote>
    </div>
  </fieldset>
  
  <fieldset>
    <legend><?=NETCAT_MODULE_SEARCH_ADMIN_INTERFACE_QUERY_SUGGEST ?></legend>
    <div class="setting">
      <input type="radio" name="s[SuggestMode]" value="queries" id="r_s1"
          <?=($suggest_enabled && $suggest_mode == 'queries' ? " checked" : "") ?>/>
      <label for="r_s1"><?=NETCAT_MODULE_SEARCH_ADMIN_INTERFACE_QUERY_SUGGEST_QUERIES ?></label>
    </div>
    <div class="setting">
      <input type="radio" name="s[SuggestMode]" value="titles" id="r_s2"
          <?=($suggest_enabled && $suggest_mode == 'titles' ? " checked" : "") ?>/>
      <label for="r_s2"><?=NETCAT_MODULE_SEARCH_ADMIN_INTERFACE_QUERY_SUGGEST_TITLES ?></label>
    </div>
    <div class="setting">
      <input type="radio" name="s[SuggestMode]" value="" id="r_s3"
          <?=(!$suggest_enabled ? " checked" : "") ?>/>
      <label for="r_s3"><?=NETCAT_MODULE_SEARCH_ADMIN_INTERFACE_QUERY_SUGGEST_DISABLED ?></label>
    </div>
    <div class="setting">
        <?=NETCAT_MODULE_SEARCH_ADMIN_INTERFACE_QUERY_SUGGEST_MINIMUM_LENGTH ?>:
        <input type='text' name='s[SuggestionsMinInputLength]' class='i3' 
               value='<?=htmlspecialchars(nc_search::get_setting('SuggestionsMinInputLength')) ?>' />
    </div>
    <div class="setting">
        <?=NETCAT_MODULE_SEARCH_ADMIN_INTERFACE_QUERY_SUGGEST_NUMBER_OF_HITS ?>:
        <input type='text' name='s[NumberOfSuggestions]' class='i3' 
               value='<?=htmlspecialchars(nc_search::get_setting('NumberOfSuggestions')) ?>' />
    </div>
  </fieldset>
  
  <fieldset>
    <legend><?=NETCAT_MODULE_SEARCH_ADMIN_INTERFACE_FORM_TEMPLATES ?></legend>
    <textarea class="code" 
     name="s[SearchFormTemplate]"><?=htmlspecialchars(nc_search::get_setting('SearchFormTemplate')) ?></textarea>
  </fieldset>

  <fieldset>
    <legend><?=NETCAT_MODULE_SEARCH_ADMIN_INTERFACE_ADVANCED_FORM_TEMPLATE ?></legend>
    <textarea class="code" 
     name="s[AdvancedSearchFormTemplate]"><?=htmlspecialchars(nc_search::get_setting('AdvancedSearchFormTemplate')) ?></textarea>
  </fieldset>
  
</form>
