<?php
/* $Id: ui.php 4290 2011-02-23 15:32:35Z denis $ */
if ( !class_exists("nc_System") ) die("Unable to load file.");
/**
  * Базовый класс для облегчения формирования UI в модулях
  */
class ui_config_module extends ui_config {

  function ui_config_module($module_keyword, $active_tab = 'admin') {
    global $nc_core;
    global $MODULE_FOLDER, $ADMIN_TEMPLATE_FOLDER;
    
    $module_data = $nc_core->modules->get_by_keyword($module_keyword, false);

    // структура для простейшего модуля
    $this->headerText = constant($module_data['Module_Name']);
    $this->headerImage = (
      file_exists($ADMIN_TEMPLATE_FOLDER."img/i_module_".$module_data['Keyword']."_big.gif")
      ? "i_module_".$module_data['Keyword']."_big.gif"
      : "i_modules_big.gif"
    );

    if ( file_exists($MODULE_FOLDER.$module_data['Keyword']."/admin.php") ) {
      $this->tabs[] = array(
        'id' => 'admin',
        'caption'=>constant($module_data['Module_Name']),
        'location' => "module.".$module_data['Keyword']
      );
    }

    $this->tabs[] = array(
      'id' => 'settings',
      'caption' => TOOLS_MODULES_MOD_PREFS,
      'location' => "module.settings(".$module_data['Keyword'].")"
    );
    
    $this->activeTab = $active_tab;
    
    switch ($active_tab) {
      case 'admin':
        $this->locationHash = "module.".$module_data['Keyword'];
      break;
      case 'settings':
        $this->locationHash = "module.settings(".$module_data['Keyword'].")";
      break;
    }
    
    $this->treeMode = "modules";
    $this->treeSelectedNode = "module-".$module_data['Module_ID'];
  }
  
}

?>